//+------------------------------------------------------------------+
//|                                              Hull moving average |
//|                                                           mladen |
//+------------------------------------------------------------------+
#property copyright "mladen"
#property link "mladenfx@gmail.com"

#property indicator_chart_window
#property indicator_buffers 3
#property indicator_color1  DeepSkyBlue
#property indicator_color2  Red
#property indicator_color3  Red
#property indicator_width1  2
#property indicator_width2  2
#property indicator_width3  2

//
//
//
//
//

extern int HMAPeriod  = 20;
extern int HMAPrice   = PRICE_CLOSE;
extern int HMAMethod  = MODE_LWMA;

//
//
//
//
//

double hma[];
double hmada[];
double hmadb[];
double work[];
double buffer2[];
double trend[];

int    HalfPeriod;
int    HullPeriod;

//+------------------------------------------------------------------
//|                                                                 |
//+------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorBuffers(5);
      SetIndexBuffer(0,hma);
      SetIndexBuffer(1,hmada);
      SetIndexBuffer(2,hmadb);
      SetIndexBuffer(3,trend);
      SetIndexBuffer(4,work);
      
   //
   //
   //
   //
   //
         
      HMAPeriod  = MathMax(2,HMAPeriod);
      HalfPeriod = MathFloor(HMAPeriod/2);
      HullPeriod = MathFloor(MathSqrt(HMAPeriod));
   IndicatorShortName("HMA ("+HMAPeriod+")");
   return(0);
}


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   int counted_bars = IndicatorCounted();
   int limit,i;
   
   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;   
           limit=MathMin(Bars-counted_bars,Bars-1);
           if (trend[limit] == -1) CleanPoint(limit,hmada,hmadb);

   //
   //
   //
   //
   //

   for(i=limit; i>=0; i--) work[i] = 2.0*iMA(NULL,0,HalfPeriod,0,HMAMethod,HMAPrice,i)-iMA(NULL,0,HMAPeriod ,0,HMAMethod,HMAPrice,i);
   for(i=limit; i>=0; i--)
   {
      hma[i]   = iMAOnArray(work,0,HullPeriod,0,HMAMethod,i);
      hmada[i] = EMPTY_VALUE;
      hmadb[i] = EMPTY_VALUE;
      trend[i] = trend[i+1];
         if (hma[i] > hma[i+1]) trend[i] =  1;
         if (hma[i] < hma[i+1]) trend[i] = -1;
         if (trend[i] == -1) PlotPoint(i,hmada,hmadb,hma);
   }      
   return(0);
}


//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

void CleanPoint(int i,double& first[],double& second[])
{
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i+1] = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
}

//
//
//
//
//

void PlotPoint(int i,double& first[],double& second[],double& from[])
{
   if (first[i+1] == EMPTY_VALUE)
      {
         if (first[i+2] == EMPTY_VALUE) {
                first[i]   = from[i];
                first[i+1] = from[i+1];
                second[i]  = EMPTY_VALUE;
            }
         else {
                second[i]   =  from[i];
                second[i+1] =  from[i+1];
                first[i]    = EMPTY_VALUE;
            }
      }
   else
      {
         first[i]  = from[i];
         second[i] = EMPTY_VALUE;
      }
}